//=============================================================================
// NtSpdSrv.c
// Program reads UDP packets
//=============================================================================
#define INCL_WIN
#define INCL_DOSPROCESS

#include <os2.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <ctype.h>
#include <netdb.h>
#include <types.h>
#include <sys\socket.h>
#include <net\if.h>
#include <arpa\inet.h>
#include <unistd.h>
#include <sys\types.h> 
#include <process.h>
#include <signal.h>
#include "NetSpeed.h"

//-----------------------------------------------------------------------------
// Global Variablies
//-----------------------------------------------------------------------------
BOOL BreakFlag = FALSE;

//=============================================================================
// Signal handling
//=============================================================================
void MyBreakHandler(int signo)
{
  BreakFlag =TRUE;
}

//=============================================================================
// Main procedure
//=============================================================================
void main(int argc, char *argv[])
{
int udpsock, i, count, len, maxnum;
unsigned short Port;
fd_set rfds;
struct timeval tv = { TIMEOUT, 0 }, tvdata = { 1, 0 };
struct sockaddr_in myaddr_udp = { 0 };
UDPPKT INITPKT, TESTPKT;
char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];

// Init the variables
  _splitpath(argv[0], drive, dir, fname, ext); 

// Check input parameters
  if ( argc < 2 )
    {
    printf("%s - Network Speed Measuring Server\n\n", fname);
    printf("Syntax:\n");
    printf("  %s <Port>\n\n", fname);
    printf("Here:\n");
    printf("  Port - UDP port number.\n");
    return;
    }

  Port = atoi(argv[1]);

// Change signal handling and write informational messages
  signal(SIGINT,   MyBreakHandler);
  signal(SIGBREAK, MyBreakHandler);

  printf("UDP port number - %d\n\n", Port);
  printf("To stop Server press Ctrl-C or Ctrl-Break\n");

// Bind to UDP port
  udpsock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

  myaddr_udp.sin_family = AF_INET;
  myaddr_udp.sin_addr.s_addr = INADDR_ANY;
  myaddr_udp.sin_port = htons(Port);

  bind(udpsock, (struct sockaddr *)&myaddr_udp, sizeof(struct sockaddr));

  FD_ZERO (&rfds);
  FD_SET (udpsock, &rfds);

  for (; !BreakFlag;)
    {
// Read for the first message
    memset((char *)&INITPKT, 0, sizeof(UDPPKT));

    printf("Waiting ...\n");
    if ( select(udpsock + 1, &rfds, NULL, NULL, &tv) <= 0 ) continue;
    len = recvfrom(udpsock, (char *)&INITPKT, sizeof(UDPPKT), 0, NULL, NULL);
    if ( len != sizeof(UDPPKT) ) continue;
    if ( strncmp(INITPKT.Msg, FirstMsgTxt, strlen(FirstMsgTxt)) != 0 )
      continue;
    if ( (INITPKT.Threads < MIN_THREADS) || (INITPKT.Threads > MAX_THREADS) )
      continue;
    if ( (INITPKT.Packets < MIN_PACKETS) || (INITPKT.Packets > MAX_PACKETS) )
      continue;

// Read test packeges
    maxnum = INITPKT.Threads*INITPKT.Packets;
    printf("Reading ...\n");

    for (i=0, count=0; i<maxnum && !BreakFlag; i++)
      {
      if ( select(udpsock + 1, &rfds, NULL, NULL, &tvdata) <= 0 ) continue;
      len = recvfrom(udpsock, (char *)&TESTPKT, sizeof(UDPPKT), 0, NULL, NULL);
      if ( len != sizeof(UDPPKT) ) continue;
      if ( strncmp(TESTPKT.Msg, TestMsgTxt, strlen(TestMsgTxt)) != 0 )
        continue;
      if ( (TESTPKT.Threads < 0) || (TESTPKT.Threads > INITPKT.Threads) )
        continue;
      if ( (TESTPKT.Packets < 0) || (TESTPKT.Packets > INITPKT.Packets) )
        continue;

      count++;
      }
    if ( BreakFlag ) break;

// Print report
    printf("Expected number of packets - %d\n", maxnum);
    printf("Received number of packets - %d\n", count);
    }

// End of program
  soclose(udpsock);
  printf("Finish\n");
}
